script_name("call vehicle by image")
script_author("Um Geek")
script_url("https://gta-geek.blogspot.com.br/")
script_version_number(11);

local imgui = require 'imgui'
local path = string.format('%s\\moonloader\\resource\\call vehicle by image\\',getGameDirectory())
local texts = {
    tittle = thisScript().name..' '..(thisScript().version/10)..' - '..thisScript().authors[1],
    text_1 = 'veiculo indiscartavel',
    text_2 = 'atrás do veiculo existente',
    text_3 = 'Ops! indisponivel!',        
}

local pictures = {}
local extras = {}
local gui = {
    no_remove = imgui.ImBool(false),
    is_trailer = imgui.ImBool(false),
}

function imgui.OnDrawFrame()
    local sx, sy = getScreenResolution()
    local sw,sh = 420,160
    local imgw,imgh = 120,80
    local scs = script.list()
    imgui.SetNextWindowPos(imgui.ImVec2(2,sy-(sh+2)),imgui.Cond.FirstUseEver)
    imgui.SetNextWindowSize(imgui.ImVec2(sx-4,sh), imgui.Cond.FirstUseEver)
    imgui.Begin(texts.tittle,nil,1+2+4+32+128+2048)
    --
    imgui.Text(texts.tittle)
    imgui.Separator()    
    imgui.Checkbox(texts.text_1, gui.no_remove)
    imgui.SameLine()
    imgui.Checkbox(texts.text_2, gui.is_trailer)   
    imgui.Separator()  
    for i,e in ipairs(pictures) do
        if imgui.ImageButton(e.pic,imgui.ImVec2(imgw,imgh),imgui.ImVec2(0,0),imgui.ImVec2(1,1),1,imgui.ImVec4(0,0,0,0),imgui.ImVec4(1,1,1,1)) then 
            local vehicle = spawner(e.id)
            if vehicle then
                local gxt = getNameOfVehicleModel(e.id)
                local name = getGxtText(gxt)  
                local msg = '~y~'..thisScript().name  
                msg = msg..'~w~~n~Name: '..name 
                msg = msg..'~n~Model: '..e.id
                printHelpString(msg) 
                imgui.Process = not imgui.Process   
            end
        end        
        imgui.SameLine()
    end
    imgui.End()
end

function main()
    repeat 
        if isPlayerControlOn(PLAYER_HANDLE) then 
            if isKeyDown(0x57) and wasKeyPressed(0x55) then -- w + u
                -- load
                if #pictures <= 0 then 
                    for i=400, 611 do 
                        table.insert(pictures,{id=i,pic=imgui.CreateTextureFromFile(string.format('%sVehicle_%i.jpg',path,i))})
                    end
                    load_extra_models();
                end
                imgui.Process = not imgui.Process
                setPlayerControl(PLAYER_HANDLE,false)
                setCameraBehindPlayer()
                while imgui.Process do 
                    if isKeyDown(0x57) and wasKeyPressed(0x55) then
                        break 
                    end
                    wait(4)
                end
                setPlayerControl(PLAYER_HANDLE,true)
                restoreCamera()
            end
        end
        wait(4);
    until false
end

local prev_vehicle = nil
function spawner(id)
    if isModelAvailable(id) then 
        if not hasModelLoaded(id) then 
            requestModel(id)
            loadAllModelsNow()
        end
        local x,y,z = getOffsetFromCharInWorldCoords(PLAYER_PED,0.0,8.0,0.0)
        if doesVehicleExist(prev_vehicle) and gui.is_trailer.v then 
            x,y,z = getOffsetFromCarInWorldCoords(prev_vehicle,0.0,-10.0,0.0)
        end
        local a = getCharHeading(PLAYER_PED)
        local vehicle = createCar(id,x,y,z)
        setCarHeading(vehicle,a+90)
        markModelAsNoLongerNeeded(id)
        if not gui.no_remove.v then
            prev_vehicle = nil
            markCarAsNoLongerNeeded(vehicle)
        else 
            prev_vehicle = vehicle
        end
        return doesVehicleExist(vehicle)
    else 
        printHelpString(texts.text_3..'~n~Model: '..id)
    end
    return false
end

function onExitScript(quitGame)
    for i,e in ipairs(pictures) do
        imgui.ReleaseTexture(e.pic)
    end
end

function load_extra_models()
    local data = path..'_extras.txt'
    if doesFileExist(data) then 
        local handle = io.open(data, "r")
        for line in handle:lines() do
            local s = string.format('%s%i.jpg',path,line)
            if doesFileExist(s) then
                table.insert(pictures,{id=tonumber(line),pic=imgui.CreateTextureFromFile(s)})
            else
                print('No found:'..s)
            end
        end   
    end
end